typedef struct winPos{
		int x;
		int y;
		int w;
		int h;
		int v;
	} winPos;

char *getConfigFileName(void){
	static char *cp,st[PATH_MAX];
#ifdef WIN32
	cp=getenv("USERPROFILE");
#else
	cp=getenv("HOME");
#endif
	if(!cp) return 0;
	strcpy(st,cp);
#ifdef WIN32
	strcat(st,"/avrsim.ini");
#else
	strcat(st,"/.config/avrsim.conf");
#endif
	return st;
}

void readConfigLine(char *st,
		winPos *main_wp,
		winPos *terminal_wp,
		winPos *disass_wp,
		winPos *ram_wp,
		winPos *eeprom_wp,
		winPos *flash_wp,
		winPos *src_wp,
		winPos *tree_wp
		){
	char *cp;
	int i;
	if(cp=strchr(st,'\n')) *cp=0;
	cp=strchr(st,'=');
	if(!cp) return;
	*cp=0;
	cp++;
	i=atoi(cp);
	if(!strcmp(st,"main_window_x")){
		main_wp->x=i;
		return;}
	if(!strcmp(st,"main_window_y")){
		main_wp->y=i;
		return;}
	if(!strcmp(st,"main_window_w")){
		main_wp->w=i;
		return;}
	if(!strcmp(st,"main_window_h")){
		main_wp->h=i;
		return;}
	if(!strcmp(st,"terminal_window_x")){
		terminal_wp->x=i;
		return;}
	if(!strcmp(st,"terminal_window_y")){
		terminal_wp->y=i;
		return;}
	if(!strcmp(st,"terminal_window_w")){
		terminal_wp->w=i;
		return;}
	if(!strcmp(st,"terminal_window_h")){
		terminal_wp->h=i;
		return;}
	if(!strcmp(st,"terminal_window_v")){
		terminal_wp->v=i;
		return;}
	if(!strcmp(st,"disass_window_x")){
		disass_wp->x=i;
		return;}
	if(!strcmp(st,"disass_window_y")){
		disass_wp->y=i;
		return;}
	if(!strcmp(st,"disass_window_w")){
		disass_wp->w=i;
		return;}
	if(!strcmp(st,"disass_window_h")){
		disass_wp->h=i;
		return;}
	if(!strcmp(st,"disass_window_v")){
		disass_wp->v=i;
		return;}
	if(!strcmp(st,"ram_window_x")){
		ram_wp->x=i;
		return;}
	if(!strcmp(st,"ram_window_y")){
		ram_wp->y=i;
		return;}
	if(!strcmp(st,"ram_window_w")){
		ram_wp->w=i;
		return;}
	if(!strcmp(st,"ram_window_h")){
		ram_wp->h=i;
		return;}
	if(!strcmp(st,"ram_window_v")){
		ram_wp->v=i;
		return;}
	if(!strcmp(st,"eeprom_window_x")){
		eeprom_wp->x=i;
		return;}
	if(!strcmp(st,"eeprom_window_y")){
		eeprom_wp->y=i;
		return;}
	if(!strcmp(st,"eeprom_window_w")){
		eeprom_wp->w=i;
		return;}
	if(!strcmp(st,"eeprom_window_h")){
		eeprom_wp->h=i;
		return;}
	if(!strcmp(st,"eeprom_window_v")){
		eeprom_wp->v=i;
		return;}
	if(!strcmp(st,"flash_window_x")){
		flash_wp->x=i;
		return;}
	if(!strcmp(st,"flash_window_y")){
		flash_wp->y=i;
		return;}
	if(!strcmp(st,"flash_window_w")){
		flash_wp->w=i;
		return;}
	if(!strcmp(st,"flash_window_h")){
		flash_wp->h=i;
		return;}
	if(!strcmp(st,"flash_window_v")){
		flash_wp->v=i;
		return;}
	if(!strcmp(st,"src_window_x")){
		src_wp->x=i;
		return;}
	if(!strcmp(st,"src_window_y")){
		src_wp->y=i;
		return;}
	if(!strcmp(st,"src_window_w")){
		src_wp->w=i;
		return;}
	if(!strcmp(st,"src_window_h")){
		src_wp->h=i;
		return;}
	if(!strcmp(st,"src_window_v")){
		src_wp->v=i;
		return;}
	if(!strcmp(st,"tree_window_x")){
		tree_wp->x=i;
		return;}
	if(!strcmp(st,"tree_window_y")){
		tree_wp->y=i;
		return;}
	if(!strcmp(st,"tree_window_w")){
		tree_wp->w=i;
		return;}
	if(!strcmp(st,"tree_window_h")){
		tree_wp->h=i;
		return;}
	if(!strcmp(st,"tree_window_v")){
		tree_wp->v=i;
		return;}
	if(!strcmp(st,"codefile")){
		if(!strlen(fn_hexFile)) readCodeFile(cp);
		return;}
	if(!strcmp(st,"f_cpu")){
		f_cpu=i;
		return;}
	if(!strcmp(st,"breakpoint")){
		brkp=i;
		return;}
	if(!strcmp(st,"includepath")){
		strcpy(includePath,cp);
		return;}
	if(!strcmp(st,"definitions")){
		strcpy(definitions,cp);
		readDefFile();
		return;}
}

void writeConfig(void){
	FILE *f;
	char *cp;
	int offs;	/* Höhe der Titelleiste */
	cp=getConfigFileName();
	if(!cp){
		fl_alert("%s kann nicht geschrieben werden!",cp);
		return;
	}
	f=fopen(cp,"w");
	if(!f) return;
	offs=21;	/* Höhe Titelleiste */
	fprintf(f,"main_window_x=%d\n",ui->main_win->x());
	fprintf(f,"main_window_y=%d\n",ui->main_win->y()-offs);
	fprintf(f,"main_window_w=%d\n",ui->main_win->w());
	fprintf(f,"main_window_h=%d\n",ui->main_win->h());
	fprintf(f,"terminal_window_x=%d\n",ui->terminal_win->x());
	fprintf(f,"terminal_window_y=%d\n",ui->terminal_win->y()-offs);
	fprintf(f,"terminal_window_w=%d\n",ui->terminal_win->w());
	fprintf(f,"terminal_window_h=%d\n",ui->terminal_win->h());
	fprintf(f,"terminal_window_v=%d\n",ui->terminal_win->visible());
	fprintf(f,"disass_window_x=%d\n",ui->disass_win->x());
	fprintf(f,"disass_window_y=%d\n",ui->disass_win->y()-offs);
	fprintf(f,"disass_window_w=%d\n",ui->disass_win->w());
	fprintf(f,"disass_window_h=%d\n",ui->disass_win->h());
	fprintf(f,"disass_window_v=%d\n",ui->disass_win->visible());
	fprintf(f,"ram_window_x=%d\n",ram_win->x());
	fprintf(f,"ram_window_y=%d\n",ram_win->y()-offs);
	fprintf(f,"ram_window_w=%d\n",ram_win->w());
	fprintf(f,"ram_window_h=%d\n",ram_win->h());
	fprintf(f,"ram_window_v=%d\n",ram_win->visible());
	fprintf(f,"eeprom_window_x=%d\n",eeprom_win->x());
	fprintf(f,"eeprom_window_y=%d\n",eeprom_win->y()-offs);
	fprintf(f,"eeprom_window_w=%d\n",eeprom_win->w());
	fprintf(f,"eeprom_window_h=%d\n",eeprom_win->h());
	fprintf(f,"eeprom_window_v=%d\n",eeprom_win->visible());
	fprintf(f,"flash_window_x=%d\n",flash_win->x());
	fprintf(f,"flash_window_y=%d\n",flash_win->y()-offs);
	fprintf(f,"flash_window_w=%d\n",flash_win->w());
	fprintf(f,"flash_window_h=%d\n",flash_win->h());
	fprintf(f,"flash_window_v=%d\n",flash_win->visible());
	fprintf(f,"src_window_x=%d\n",ui->src_win->x());
	fprintf(f,"src_window_y=%d\n",ui->src_win->y()-offs);
	fprintf(f,"src_window_w=%d\n",ui->src_win->w());
	fprintf(f,"src_window_h=%d\n",ui->src_win->h());
	fprintf(f,"src_window_v=%d\n",ui->src_win->visible());
	fprintf(f,"tree_window_x=%d\n",tree_win->x());
	fprintf(f,"tree_window_y=%d\n",tree_win->y()-offs);
	fprintf(f,"tree_window_w=%d\n",tree_win->w());
	fprintf(f,"tree_window_h=%d\n",tree_win->h());
	fprintf(f,"tree_window_v=%d\n",tree_win->visible());
	fprintf(f,"f_cpu=%ld\n",f_cpu);
	fprintf(f,"breakpoint=%d\n",brkp);
	if(strlen(includePath)) fprintf(f,"includepath=%s\n",includePath);
	if(strlen(definitions)) fprintf(f,"definitions=%s\n",definitions);
	if(strlen(fn_hexFile)) fprintf(f,"codefile=%s\n",fn_hexFile);
	fclose(f);
}

void readConfig(void){
	FILE *f;
	char *cp,st[12*PATH_MAX];
	winPos main_wp,terminal_wp,disass_wp,ram_wp,eeprom_wp,flash_wp,src_wp,tree_wp;
	main_wp.x=330;
	main_wp.y=580;
	main_wp.w=320;
	main_wp.h=350;
	terminal_wp.x=550;
	terminal_wp.y=200;
	terminal_wp.w=430;
	terminal_wp.h=180;
	terminal_wp.v=0;
	disass_wp.x=30;
	disass_wp.y=30;
	disass_wp.w=300;
	disass_wp.h=900;
	disass_wp.v=1;
	ram_wp.x=850;
	ram_wp.y=30;
	ram_wp.w=380;
	ram_wp.h=900;
	ram_wp.v=1;
	eeprom_wp.x=1230;
	eeprom_wp.y=500;
	eeprom_wp.w=380;
	eeprom_wp.h=430;
	eeprom_wp.v=0;
	flash_wp.x=1230;
	flash_wp.y=30;
	flash_wp.w=380;
	flash_wp.h=450;
	flash_wp.v=0;
	src_wp.x=330;
	src_wp.y=30;
	src_wp.w=520;
	src_wp.h=530;
	src_wp.v=1;
	tree_wp.x=1230;
	tree_wp.y=500;
	tree_wp.w=380;
	tree_wp.h=430;
	tree_wp.v=1;
	cp=getConfigFileName();
	if(!cp) return;
	f=fopen(cp,"r");
	if(f){
		while(fgets(st,12*PATH_MAX-10,f)){
			readConfigLine(st,&main_wp,&terminal_wp,&disass_wp,
				&ram_wp,&eeprom_wp,&flash_wp,&src_wp,&tree_wp);
		}
		fclose(f);
	}
	ui->main_win->resize(main_wp.x,main_wp.y,main_wp.w,main_wp.h);
	ui->terminal_win->resize(terminal_wp.x,terminal_wp.y,terminal_wp.w,terminal_wp.h);
	if(terminal_wp.v) ui->terminal_win->show();
	ui->disass_win->resize(disass_wp.x,disass_wp.y,disass_wp.w,disass_wp.h);
	if(disass_wp.v) ui->disass_win->show();
	ram_win->resize(ram_wp.x,ram_wp.y,ram_wp.w,ram_wp.h);
	if(ram_wp.v) ram_win->show();
	eeprom_win->resize(eeprom_wp.x,eeprom_wp.y,eeprom_wp.w,eeprom_wp.h);
	if(eeprom_wp.v) eeprom_win->show();
	flash_win->resize(flash_wp.x,flash_wp.y,flash_wp.w,flash_wp.h);
	if(flash_wp.v) flash_win->show();
	ui->src_win->resize(src_wp.x,src_wp.y,src_wp.w,src_wp.h);
	if(src_wp.v) ui->src_win->show();
	tree_win->resize(tree_wp.x,tree_wp.y,tree_wp.w,tree_wp.h);
	if(tree_wp.v) tree_win->show();
	ui->settings_win->position(main_wp.x,main_wp.y);
}
